<?php
  //
  //
  // Broadcast Management Rivendell Cart data exporter.
  // Copyright 2018 Jonathan Cohen. Version 1.00 Release date 2018-06-16.
  // More info: www.radiotools.uk or for commercial support www.broadcast.management.
  //
  //
  // User settings. You need to configure these for your system:
  $servername = "localhost";
  $username = "root";
  $password = "password";
  $dbname = "Rivendell";







  // Start of main code.
  //
  //
  // Get the argument passed to the script and give an error if no cart selected.
  //
  if ( ! isset($argv[1])) {  // Fix for undefined offset error if no argument passed.
   $argv[1] = null;
  }
  //
  $selectedlog=$argv[1];
  if ($selectedlog == '' ) {
    echo "\nBroadcast Management Rivendell cart exporter.\n";
    echo "Copyright 2018 Jonathan Cohen. Version 1.01 Release date 2018-06-17.\n";
    echo "More info: www.radiotools.uk or for commercial support www.broadcast.management.\n\n";
    //
    echo "ERROR: You need to pass the name of the cart to export to the script. \n";
    echo "For example: php bcexport.php 100001\n\n";
    exit; // Ouch.
  }
  $cartnumber=$selectedlog;



  // Extra sanity check for log names. Just in case a really short name is accidentally entered we don't want it to do something silly.
  if (strlen($cartnumber) < 3) {
    echo "\n\nERROR: The cart number entered (".$cartnumber.") is less than 3 characters. For safety please use cart numbers of 3 or more characters.\n\n";
    exit;
  }
  //
  //
  echo "\nCart selected: ".$cartnumber."\n";





  // Create database connection.
  $conn1 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn1->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }
    

  // Create database connection.
  $conn2 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn2->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }




  // Before we start, scan through every cart on the system and find the highest current USC number we have set.
  $sql1 = "SELECT * FROM CART WHERE NUMBER=".$cartnumber;
  $result1 = $conn1->query($sql1);
  //
  $ret_NUMBER='';   // Set to blank so we can check if we found a valid cart later.
  //
  if ($result1->num_rows > 0) {
    // output data of first cart found (we can make the assumption of only one as the CART row is unique).
    while($row1 = $result1->fetch_assoc()) {
      $ret_NUMBER = $row1['NUMBER'];
      $ret_TITLE = $row1['TITLE'];
      $ret_ARTIST = $row1['ARTIST'];  
      $ret_ALBUM = $row1['ALBUM'];
      $ret_YEAR = $row1['YEAR'];
      $ret_LABEL = $row1['LABEL'];
      $ret_CONDUCTOR = $row1['CONDUCTOR'];
      $ret_CLIENT= $row1['CLIENT'];
      $ret_AGENCY = $row1['AGENCY'];
      $ret_PUBLISHER = $row1['PUBLISHER'];
      $ret_COMPOSER = $row1['COMPOSER'];
      $ret_USER_DEFINED = $row1['USER_DEFINED'];
      $ret_SONG_ID  = $row1['SONG_ID'];
      $ret_BPM = $row1['BPM'];
      $ret_FORCED_LENGTH = $row1['FORCED_LENGTH'];
      $ret_AVERAGE_LENGTH = $row1['AVERAGE_LENGTH'];
      $ret_LENGTH_DEVIATION = $row1['LENGTH_DEVIATION'];
      $ret_AVERAGE_SEGUE_LENGTH = $row1['AVERAGE_SEGUE_LENGTH'];
      $ret_AVERAGE_HOOK_LENGTH = $row1['AVERAGE_HOOK_LENGTH'];
      $ret_SCHED_CODES = $row1['SCHED_CODES'];
      $ret_NOTES = $row1['NOTES'];
      $ret_GROUP_NAME = $row1['GROUP_NAME'];
    }
  }
  $conn1->close();


  if ( $ret_NUMBER != '') {
    //
    // We have found a valid cart so export the data!
    //
    // But first we get more data from the CUTS table.
    $sql2 = "SELECT * FROM CUTS WHERE CART_NUMBER=".$cartnumber;
    $result2 = $conn2->query($sql2);
    if ($result2->num_rows > 0) {
      while($row2 = $result2->fetch_assoc()) {
        $ret_DESCRIPTION = $row2['DESCRIPTION'];
        $ret_LENGTH = $row2['LENGTH'];
        $ret_ORIGIN_DATETIME = $row2['ORIGIN_DATETIME'];
        $ret_ORIGIN_NAME = $row2['ORIGIN_NAME'];
        $ret_START_POINT = $row2['START_POINT'];
        $ret_END_POINT = $row2['END_POINT'];
        $ret_SEGUE_START_POINT = $row2['SEGUE_START_POINT'];
        $ret_SEGUE_END_POINT = $row2['SEGUE_END_POINT'];
        $ret_SEGUE_GAIN = $row2['SEGUE_GAIN'];
        $ret_TALK_START_POINT = $row2['TALK_START_POINT'];
        $ret_TALK_END_POINT = $row2['TALK_END_POINT'];
      }
    }
    $conn2->close();
    //
    //
    // Write the .dat file for the cart.
    $myfile = fopen($cartnumber.".dat", "w") or die("Unable to open file!");
    //
    $txt = $ret_NUMBER."\n";
    fwrite($myfile, $txt);
    $txt = $ret_TITLE."\n";
    fwrite($myfile, $txt);
    $txt = $ret_ARTIST."\n";
    fwrite($myfile, $txt);
    $txt = $ret_ALBUM."\n";
    fwrite($myfile, $txt);
    $txt = $ret_YEAR."\n";
    fwrite($myfile, $txt);
    $txt = $ret_LABEL."\n";
    fwrite($myfile, $txt);
    $txt = $ret_CONDUCTOR."\n";
    fwrite($myfile, $txt);
    $txt = $ret_CLIENT."\n";
    fwrite($myfile, $txt);
    $txt = $ret_AGENCY."\n";
    fwrite($myfile, $txt);
    $txt = $ret_PUBLISHER."\n";
    fwrite($myfile, $txt);
    $txt = $ret_COMPOSER."\n";
    fwrite($myfile, $txt);
    $txt = $ret_USER_DEFINED."\n";
    fwrite($myfile, $txt);
    $txt = $ret_SONG_ID."\n";
    fwrite($myfile, $txt);
    
    $txt = $ret_BPM."\n";
    fwrite($myfile, $txt);
    $txt = $ret_FORCED_LENGTH."\n";
    fwrite($myfile, $txt);
    $txt = $ret_AVERAGE_LENGTH."\n";
    fwrite($myfile, $txt);
    $txt = $ret_LENGTH_DEVIATION."\n";
    fwrite($myfile, $txt);
    $txt = $ret_AVERAGE_SEGUE_LENGTH."\n";
    fwrite($myfile, $txt);
    $txt = $ret_AVERAGE_HOOK_LENGTH."\n";
    fwrite($myfile, $txt);
    $txt = $ret_SCHED_CODES."\n"; 
    fwrite($myfile, $txt);
    $txt = "===============================\n";
    fwrite($myfile, $txt);
    $txt = $ret_DESCRIPTION."\n";
    fwrite($myfile, $txt);
    $txt = $ret_LENGTH."\n";
    fwrite($myfile, $txt);
    $txt = $ret_ORIGIN_DATETIME."\n";
    fwrite($myfile, $txt);
    $txt = $ret_ORIGIN_NAME."\n";
    fwrite($myfile, $txt);
    $txt = $ret_START_POINT."\n";
    fwrite($myfile, $txt);
    $txt = $ret_END_POINT."\n";
    fwrite($myfile, $txt);
    $txt = $ret_SEGUE_START_POINT."\n";
    fwrite($myfile, $txt);
    $txt = $ret_SEGUE_END_POINT."\n";
    fwrite($myfile, $txt);
    $txt = $ret_SEGUE_GAIN."\n";
    fwrite($myfile, $txt);
    $txt = $ret_TALK_START_POINT."\n";
    fwrite($myfile, $txt);
    $txt = $ret_TALK_END_POINT."\n";
    fwrite($myfile, $txt);
    $txt = "===========\n";
    fwrite($myfile, $txt);
    $txt = $ret_GROUP_NAME."\n";
    fwrite($myfile, $txt);
    //
    fclose($myfile);



    // Write the cart notes to a seperate .not file for the cart.
    $myfile = fopen($cartnumber.".not", "w") or die("Unable to open file!");
    $txt = $ret_NOTES."\n";
    fwrite($myfile, $txt);
    fclose($myfile);


//debug
echo $ret_NUMBER."\n";
echo $ret_TITLE."\n";
echo $ret_ARTIST."\n";
//echo $ret_ALBUM."\n";
//echo $ret_YEAR."\n";
//echo $ret_LABEL."\n";
//echo $ret_CONDUCTOR."\n";
//echo $ret_CLIENT."\n";
//echo $ret_AGENCY."\n";
//echo $ret_PUBLISHER."\n";
//echo $ret_COMPOSER."\n";
//echo $ret_USER_DEFINED."\n";
//echo $ret_SONG_ID."\n";
//echo $ret_BPM."\n";
//echo $ret_FORCED_LENGTH."\n";
//echo $ret_AVERAGE_LENGTH."\n";
//echo $ret_LENGTH_DEVIATION."\n";
//echo $ret_AVERAGE_SEGUE_LENGTH."\n";
//echo $ret_AVERAGE_HOOK_LENGTH."\n";
//echo $ret_SCHED_CODES."\n";    
//echo "===============================\n";
echo $ret_DESCRIPTION."\n";
//echo $ret_LENGTH."\n";
//echo $ret_ORIGIN_DATETIME."\n";
//echo $ret_ORIGIN_NAME."\n";
//echo $ret_START_POINT."\n";
//echo $ret_END_POINT."\n";
//echo $ret_SEGUE_START_POINT."\n";
//echo $ret_SEGUE_END_POINT."\n";
//echo $ret_SEGUE_GAIN."\n";
//echo $ret_TALK_START_POINT."\n";
//echo $ret_TALK_END_POINT."\n";
echo $ret_GROUP_NAME."\n";
echo "===============================\n";
echo $ret_NOTES."\n";

  
    // We save our .dat file and also use the rdexport command to get the audio and an XML file with many (but not all) of the same details.
    // Export the audio as FLAC.
    // rdexport --carts=100001:100001 --format=FLAC --xml /tmp
    $currentdir=getcwd();
    $output = shell_exec('rdexport --carts='.$cartnumber.':'.$cartnumber.' --format=FLAC --xml '.$currentdir);
    echo "RDEXPORT: $output \n";

    
      
    //
   } else {
    //
    // Not a valis cart. Give an error.
    echo "ERROR: CART NOT FOUND. \n\n";
   }



?>