<?php
  //
  //
  // Broadcast Management Rivendell Cart group exporter.
  // Copyright 2018 Jonathan Cohen. Version 1.00 Release date 2018-06-16.
  // More info: www.radiotools.uk or for commercial support www.broadcast.management.
  //
  //
  // User settings. You need to configure these for your system:
  $servername = "localhost";
  $username = "root";
  $password = "password";
  $dbname = "Rivendell";







  // Start of main code.
  //
  //
  // Get the argument passed to the script and give an error if no cart selected.
  //
  if ( ! isset($argv[1])) {  // Fix for undefined offset error if no argument passed.
   $argv[1] = null;
  }
  //
  $selectedlog=$argv[1];
  if ($selectedlog == '' ) {
    echo "\nBroadcast Management Rivendell group exporter.\n";
    echo "Copyright 2018 Jonathan Cohen. Version 1.00 Release date 2018-06-17.\n";
    echo "More info: www.radiotools.uk or for commercial support www.broadcast.management.\n\n";
    //
    echo "ERROR: You need to pass the name of the GROUP to export to the script. \n";
    echo "For example: php bcgroupexport.php TRAFFIC\n\n";
    exit; // Ouch.
  }
  $cartgroup=$selectedlog;



  // Extra sanity check for log names. Just in case a really short name is accidentally entered we don't want it to do something silly.
  if (strlen($cartgroup) < 2) {
    echo "\n\nERROR: The group name entered (".$cartgroup.") is less than 2 characters. For safety please use group names of 2 or more characters.\n\n";
    exit;
  }
  //
  //
  echo "\nGroup selected: ".$cartgroup."\n";





  // Create database connection.
  $conn1 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn1->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }
    

  // Create database connection.
  $conn2 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn2->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }






  // Check the group exists.
  $sql1 = "SELECT * FROM GROUPS WHERE NAME='".$cartgroup."'";
  $result1 = $conn1->query($sql1);
  if ($result1->num_rows > 0) {
    while($row1 = $result1->fetch_assoc()) {
      $ret2_NAME = $row1['NAME'];
      $ret2_DEFAULT_CART_TYPE = $row1['DEFAULT_CART_TYPE'];
      $ret2_ENFORCE_CART_RANGE = $row1['ENFORCE_CART_RANGE'];
      // We will use these two later if we need to find the next available cart number!
      $ret2_DEFAULT_LOW_CART = $row1['DEFAULT_LOW_CART'];
      $ret2_DEFAULT_HIGH_CART = $row1['DEFAULT_HIGH_CART'];
    }
  }
  // Do the checks
  if ( $ret2_NAME != $cartgroup ) { echo "\nERROR: CART GROUP NOT FOUND.\n"; exit; }   //ouch!

  
  


  
  // We now know the group is valid.
  // Select all from this group in the CARTS database and work through exporting each one to the current folder using our existing export script!
  // SELECT * FROM CART WHERE GROUP_NAME='MUSIC' - Retreve: NUMBER (also TITLE and ARTIST for display only).
  $totalcount=0;      // Used to display total carts processed.
  //
  //
  $sql1 = "SELECT * FROM CART WHERE GROUP_NAME='".$cartgroup."'";
  $result1 = $conn1->query($sql1);
  if ($result1->num_rows > 0) {
    while($row1 = $result1->fetch_assoc()) {
      $ret_NUMBER = $row1['NUMBER'];
      $ret_TITLE = $row1['TITLE'];
      $ret_ARTIST = $row1['ARTIST'];
      //
      $totalcount = $totalcount +1;
      echo "Processing cart: $ret_NUMBER - $ret_TITLE - $ret_ARTIST\n";
      echo "***** COUNT SINCE START OF EXPORT: $totalcount *****\n";
      //
      // Call the export script
      // php /home/broadcast/rdscripts/system/bcexport.php 100001
      $currentdir=getcwd();
      $output = shell_exec('php /home/broadcast/rdscripts/system/bcexport.php '.$ret_NUMBER);
      echo "BCEXPORT output: $output \n";
      
      
    }
  }
  echo "Total carts processed: $totalcount\n\n";



?>