<?php
  //
  //
  // Broadcast Management Rivendell Cart group import.
  // Copyright 2018 Jonathan Cohen. Version 1.00 Release date 2018-06-16.
  // More info: www.radiotools.uk or for commercial support www.broadcast.management.
  //
  //
  // User settings. You need to configure these for your system:
  $servername = "localhost";
  $username = "root";
  $password = "password";
  $dbname = "Rivendell";







  // Start of main code.
  //
  //
  // Get the argument passed to the script and give an error if no cart selected.
  //
  if ( ! isset($argv[1])) {  // Fix for undefined offset error if no argument passed.
   $argv[1] = null;
  }
  //
  $selectedlog=$argv[1];
  if ($selectedlog == '' ) {
    echo "\nBroadcast Management Rivendell group importer.\n";
    echo "Copyright 2018 Jonathan Cohen. Version 1.00 Release date 2018-06-17.\n";
    echo "More info: www.radiotools.uk or for commercial support www.broadcast.management.\n\n";
    //
    echo "WARNING: THIS SCRIPT WILL IMPORT EVERY CART IN THE CURRENT DIRECTORY TO THE SELECTED GROUP!\n";
    echo "THE CART NUMBERS ASSIGNED WILL BE THE NEXT AVAILABLE IN THE SELECTED GROUP.\nEXISTING CART NUMBERS WILL NOT BE USED.\n";
    //
    echo "ERROR: You need to pass the name of the GROUP to use for importing to the script. \n";
    echo "For example: php bcgroupimport.php MUSIC\n\n";
    exit; // Ouch.
  }
  $cartgroup=$selectedlog;








  // Extra sanity check for log names. Just in case a really short name is accidentally entered we don't want it to do something silly.
  if (strlen($cartgroup) < 2) {
    echo "\n\nERROR: The group name entered (".$cartgroup.") is less than 2 characters. For safety please use group names of 2 or more characters.\n\n";
    exit;
  }
  //
  //
  echo "\nGroup selected: ".$cartgroup."\n";





  // Create database connection.
  $conn1 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn1->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }
    

  // Create database connection.
  $conn2 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn2->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }






  // Check the group exists.
  $ret2_NAME='sdfsdsdsdsdfsdf'; // Some random rubbish to stop an error if the group is not found.
  $sql1 = "SELECT * FROM GROUPS WHERE NAME='".$cartgroup."'";
  $result1 = $conn1->query($sql1);
  if ($result1->num_rows > 0) {
    while($row1 = $result1->fetch_assoc()) {
      $ret2_NAME = $row1['NAME'];
      $ret2_DEFAULT_CART_TYPE = $row1['DEFAULT_CART_TYPE'];
      $ret2_ENFORCE_CART_RANGE = $row1['ENFORCE_CART_RANGE'];
      // We will use these two later if we need to find the next available cart number!
      $ret2_DEFAULT_LOW_CART = $row1['DEFAULT_LOW_CART'];
      $ret2_DEFAULT_HIGH_CART = $row1['DEFAULT_HIGH_CART'];
    }
  }
  // Do the checks
  if ( $ret2_NAME != $cartgroup ) { echo "\nERROR: CART GROUP NOT FOUND.\n"; exit; }   //ouch!

  
  
  
  
  // Now we have the group, we need to get a listing of every cart number with a *.dat file in the current directory and work through importing them!
  // Import command: php /home/broadcast/rdscripts/system/bcimport.php $dirfileprefix NEXT $cartgroup
  //
  // Read the current directory into an array.
  $currentdir=getcwd();
  // Sort in ascending order - this is default
  $dirarray = scandir($currentdir);      // Sort in descending order: $dirarray = scandir($currentdir,1);
  $arraylines=count($dirarray);          // Note: Gives a result 1 higher than the last entry as the array starts at 0.
  //
  //$dirarray = array_diff(scandir($currentdir), array('..', '.')); // this removes the dots but leaves the array entries empty... better we just ignore any enrtys less than 4 chars in length.
//print_r($dirarray);       //debug
//echo ":".$arraylines;    //debug
  //
  $totalcount=0;    // Count how many are imported.
  //
  for ($x = 0; $x < $arraylines; $x++) {      // Note this is < not <= as we start at 0 and $arraylines contains the number of lines so is one higher!
    //
//echo "Checking file: ($x) $dirarray[$x] \n";
    // Go through each line.
    // We need to check the array line ends ".dat" and if so we use the other characters as the cart number.
    $testline="xxxxxxxxxxx".$dirarray[$x];      // We add this in case the line is too short.
    $testext=substr($testline, -4);
    if ($testext=='.dat') {
      // We have a valid file.
      $cartfile=$dirarray[$x];
      $nnn=strlen($cartfile);
      $nnn=$nnn-4;    // Remove the length of .dat
      $cartnum=substr($cartfile, 0, $nnn);
      //
      $totalcount=$totalcount+1;
      //
      echo "\n********************************************************\n";
      echo "***** COUNT SINCE START OF IMPORT: $totalcount *****\n";
      echo "********************************************************\n";
      echo "Processing original cart number $cartnum - File $x: $cartfile\n";
      echo "Importing to next available cart in group $cartgroup.\n";
      //
      // Call the import script
      // php bcimport.php 100001 NEXT MUSIC
      //$currentdir=getcwd();
      $output = shell_exec('php /home/broadcast/rdscripts/system/bcimport.php '.$cartnum.' NEXT '.$cartgroup);
      echo "BCIMPORT output: $output \n";
      //
    }
  } 


  echo "Total carts processed: $totalcount\n\n";



?>