<?php
  //
  //
  // Broadcast Management Rivendell Cart data importer.
  // Copyright 2018 Jonathan Cohen. Version 1.00 Release date 2018-06-16.
  // More info: www.radiotools.uk or for commercial support www.broadcast.management.
  //
  //
  // User settings. You need to configure these for your system:
  $servername = "localhost";
  $username = "root";
  $password = "password";
  $dbname = "Rivendell";








  // Start of main code.
  //
  //
  // Get the argument passed to the script and give an error if no cart selected.
  //
  if ( ! isset($argv[1])) {  // Fix for undefined offset error if no argument passed.
   $argv[1] = null;
  }
  if ( ! isset($argv[2])) {  // Fix for undefined offset error if no argument passed.
   $argv[2] = null;
  }
  if ( ! isset($argv[3])) {  // Fix for undefined offset error if no argument passed.
   $argv[3] = null;
  }
  $newgroup=$argv[3];
  //
  $selectedlog=$argv[1];
  $importcart=$argv[2];
  if ($selectedlog == '' OR $importcart=='') {
    echo "\nBroadcast Management Rivendell cart importer.\n";
    echo "Copyright 2018 Jonathan Cohen. Version 1.01 Release date 2018-06-17.\n";
    echo "More info: www.radiotools.uk or for commercial support www.broadcast.management.\n\n";
    //
    echo "ERROR: You need to pass the name of the cart to import and destination cart number to the script. \n";
    echo "For example: php bcimport.php 100001 200001\n\n";
    //
    echo "You can also specify an import group which MUST match an existing group.\nThis will replace the cart's existing group.\n";
    echo "For example: php bcimport.php 100001 200001 MUSIC\n\n";
    //
    echo "The second cart number can also be set to 'NEXT' which will use the next cart in the selected group. For example:\n";
    echo "For example: php bcimport.php 100001 NEXT MUSIC\n\n";
    exit; // Ouch.
  }
  $cartnumber=$selectedlog;



  // Extra sanity check for log names. Just in case a really short name is accidentally entered we don't want it to do something silly.
  if (strlen($cartnumber) < 3) {
    echo "\n\nERROR: The source cart number entered (".$cartnumber.") is less than 3 characters. For safety please use cart numbers of 3 or more characters.\n\n";
    exit;
  }
  //
  // Extra sanity check for log names. Just in case a really short name is accidentally entered we don't want it to do something silly.
  if (strlen($importcart) < 3) {
    echo "\n\nERROR: The destination cart number entered (".$importcart.") is less than 3 characters. For safety please use cart numbers of 3 or more characters.\n\n";
    exit;
  }
  //
  echo "\nCart selected: ".$cartnumber." importing to ".$importcart.".\n";
  echo "New group if any: ".$newgroup."\n";




  // Check the cart's dat file exists. If not we stop as otherwise bad things might happen!
  $filename = $cartnumber.'.dat';
  if (file_exists($filename)) {
    echo "Confirmed $filename exists.\n";
  } else {
    echo "The file $filename does not exist! Stopping to prevent damage.\n";
    exit;   // ouch!
  }



  // Create database connection.
  $conn1 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn1->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }
    

  // Create database connection.
  $conn2 = new mysqli($servername, $username, $password, $dbname);
  // Check connection
  if ($conn2->connect_error) {
    die("Connection failed: " . $conn1->connect_error);
  }





  // We use our .dat file to fix a few fields in the database that the XML misses and restore the scheduler codes.
  //
  // Read the file.
  $lll = 0;
  $handle = fopen($cartnumber.".dat", "r");
  if ($handle) {
    while (($line = fgets($handle)) !== false) {
        // process the line read.
        $line = preg_replace('/\n/','',$line);  // remove the trailing newline at end of line.
        $lll = $lll + 1;
        if ($lll == 1) { $ret_NUMBER=$line; }
        if ($lll == 2) { $ret_TITLE=$line; }
        if ($lll == 3) { $ret_ARTIST=$line; }
        if ($lll == 4) { $ret_ALBUM=$line; }
        if ($lll == 5) { $ret_YEAR=$line; }
        if ($lll == 6) { $ret_LABEL=$line; }
        if ($lll == 7) { $ret_CONDUCTOR=$line; }
        if ($lll == 8) { $ret_CLIENT=$line; }
        if ($lll == 9) { $ret_AGENCY=$line; }
        if ($lll == 10) { $ret_PUBLISHER=$line; }
        //
        if ($lll == 13) { $ret_SONG_ID=$line; }
        if ($lll == 14) { $ret_BPM=$line; }
        //
        if ($lll == 15) { $ret_FORCED_LENGTH=$line; }
        if ($lll == 16) { $ret_AVERAGE_LENGTH=$line; }
        if ($lll == 17) { $ret_LENGTH_DEVIATION=$line; }
        if ($lll == 18) { $ret_AVERAGE_SEGUE_LENGTH=$line; }
        if ($lll == 19) { $ret_AVERAGE_HOOK_LENGTH=$line; }
        if ($lll == 20) { $ret_SCHED_CODES=$line; }
        //
        if ($lll == 24) { $ret_ORIGIN_DATETIME=$line; }
        if ($lll == 25) { $ret_ORIGIN_NAME=$line; }
        if ($lll == 26) { $ret_START_POINT=$line; }
        if ($lll == 27) { $ret_END_POINT=$line; }
        if ($lll == 28) { $ret_SEGUE_START_POINT=$line; }
        if ($lll == 29) { $ret_SEGUE_END_POINT=$line; }
        if ($lll == 30) { $ret_SEGUE_GAIN=$line; }
        if ($lll == 31) { $ret_TALK_START_POINT=$line; }
        if ($lll == 32) { $ret_TALK_END_POINT=$line; }
        // 33 is the ==== line
        if ($lll == 34) { $ret_GROUP_NAME=$line; }
    }
    fclose($handle);
  } else {
    // error opening the file.
    echo "DAT FILE READ ERROR.\n";
  }
  


// Debug: The fields we need are:
echo "\n\n";
echo $ret_NUMBER."\n";
echo $ret_TITLE."\n";
echo $ret_ARTIST."\n";
echo $ret_ALBUM."\n";
echo $ret_YEAR."\n";
echo $ret_LABEL."\n";
echo $ret_CONDUCTOR."\n";
echo $ret_CLIENT."\n";
echo $ret_AGENCY."\n";
echo $ret_PUBLISHER."\n";
//echo $ret_COMPOSER."\n";
//echo $ret_USER_DEFINED."\n";
echo $ret_SONG_ID."\n";             //<<<<<<<<
echo $ret_BPM."\n";                                       //<<<<<<<
echo $ret_FORCED_LENGTH."\n";          //           <<<<
echo $ret_AVERAGE_LENGTH."\n";           //         <<<<
echo $ret_LENGTH_DEVIATION."\n";
echo $ret_AVERAGE_SEGUE_LENGTH."\n";        //      <<<<
echo $ret_AVERAGE_HOOK_LENGTH."\n";
echo $ret_SCHED_CODES."\n";                   //    <<<<
//echo "===============================\n";
//echo $ret_DESCRIPTION."\n";
//echo $ret_LENGTH."\n";
echo $ret_ORIGIN_DATETIME."\n";                 //  <<<<
echo $ret_ORIGIN_NAME."\n";                       //<<<<
echo $ret_START_POINT."\n";              //         <<<<
echo $ret_END_POINT."\n";                  //       <<<<  
echo $ret_SEGUE_START_POINT."\n";            //     <<<<
echo $ret_SEGUE_END_POINT."\n";                //   <<<<
echo $ret_SEGUE_GAIN."\n";                       // <<<<
echo $ret_TALK_START_POINT."\n";            //      <<<<
echo $ret_TALK_END_POINT."\n";              //    <<<<
echo "=========\n";
echo $ret_GROUP_NAME."\n";              //    <<<<


  // Get the seperate .not file with any cart notes - this can be anything from empty to a long document!
  $allthenotes='';
  $handle = fopen($cartnumber.".not", "r");
  if ($handle) {
    while (($line = fgets($handle)) !== false) {
        // process the line read.
        $allthenotes = $allthenotes.$line;
    }
    fclose($handle);
  } else {
    // error opening the file.
    echo "NOT FILE READ ERROR.\n";
  }
  

  // Delimit the string so it can be used with mysql.
  $allthenotes = mysql_escape_mimic($allthenotes);
  

echo "=========\nNOTES:\n".$allthenotes."\n";



  // At this point $ret_GROUP_NAME has the group name from our import file.
  // We need to do some sanity checking and replace it with any group provided on the command line.
  // The group then needs to be checked to confirm it exists and if not we must stop here before bad things happen.
  //
  // Was a group specified on the command line? If so replace $ret_GROUP_NAME with this.
  //
  if ( $newgroup != '' ) { $ret_GROUP_NAME = $newgroup; }   // Replace the group with the user chosen one.
  //
  //
  // Check group exists and stop if not.
  // Check the GROUPS table to match $ret_GROUP_NAME againts "NAME". Also check that "DEFAULT_CART_TYPE" is 1 (audio) and "ENFORCE_CART_RANGE" is N to avoid rdimport failing.
  //
  $sql1 = "SELECT * FROM GROUPS WHERE NAME='".$ret_GROUP_NAME."'";
  $result1 = $conn1->query($sql1);
  if ($result1->num_rows > 0) {
    while($row1 = $result1->fetch_assoc()) {
      $ret2_NAME = $row1['NAME'];
      $ret2_DEFAULT_CART_TYPE = $row1['DEFAULT_CART_TYPE'];
      $ret2_ENFORCE_CART_RANGE = $row1['ENFORCE_CART_RANGE'];
      // We will use these two later if we need to find the next available cart number!
      $ret2_DEFAULT_LOW_CART = $row1['DEFAULT_LOW_CART'];
      $ret2_DEFAULT_HIGH_CART = $row1['DEFAULT_HIGH_CART'];
    }
  }
  // Do the checks
  if ( $ret2_NAME != $ret_GROUP_NAME ) { echo "\nERROR: CART GROUP NOT FOUND. NOT IMPORTING TO AVOID DATABASE ISSUES.\n"; exit; }   //ouch!
  if ( $ret2_DEFAULT_CART_TYPE != "1" ) { echo "\nERROR: CART GROUP IS NOT TYPE 1 (AUDIO). Type is $ret2_DEFAULT_CART_TYPE. NOT IMPORTING TO AVOID DATABASE ISSUES.\n"; exit; }   //ouch!
  if ( $ret2_ENFORCE_CART_RANGE != 'N' ) { echo "\nERROR: CART GROUP DOES NOT HAVE ENFORCE_CART_RANGE SET TO N. Type is $ret2_ENFORCE_CART_RANGE. NOT IMPORTING TO AVOID DATABASE ISSUES.\n"; exit; }   //ouch!
  
  
  
  
  
  
  
  // if $importcart is "NEXT" we need to use the next available cart number in group $ret_GROUP_NAME.
  // HOWEVER, we also need $importcart to contain this number which means we can't rely on RDimport's next cart feature.
  // We therefore need to work out this number from the database and store it in $importcart ourselves!
  if ($importcart == 'NEXT' ) {
    //
    // We need to get and store in $importcart the next available UNUSED cart number in group $ret_GROUP_NAME.
    // We already have $ret2_DEFAULT_LOW_CART and $ret2_DEFAULT_HIGH_CART from a previous function.
    //
    echo "\nFinding first available cart number for group ($ret_GROUP_NAME) between ($ret2_DEFAULT_LOW_CART) and ($ret2_DEFAULT_HIGH_CART).\n";
    //
    for ($x = $ret2_DEFAULT_LOW_CART; $x <= $ret2_DEFAULT_HIGH_CART; $x++) {
      //
      // Check if $x is available in the database and if it is, stop the loop.
      $ret3_NUMBER='FREE'; // Make sure it's set to something to look for, before each query. If the query is unsuccessful this will be left unchanged.
      $sql1 = "SELECT * FROM CART WHERE NUMBER='".$x."'";
      $result1 = $conn1->query($sql1);
      if ($result1->num_rows > 0) {
        while($row1 = $result1->fetch_assoc()) {
          $ret3_NUMBER = $row1['NUMBER'];
        }
      }
//echo "$x:::$ret3_NUMBER\n";
      //
      // If we find an empty cart we exit the loop.
      if ($ret3_NUMBER == 'FREE') { break; }
//echo ".";
    } 



    if ( $x >= $ret2_DEFAULT_HIGH_CART ) {
      // No free cart numbers in group!
      echo "\nERROR: NO FREE CART NUMBERS APPEAR TO BE AVAILABLE. CART NOT IMPORTED. Next number in group: $x.\n\n";
      exit; //ouch. Yeah yeah I know.
    }


    echo "\n***** FOUND AND USING AVAILABLE CART NUMBER $x *****\n\n";
    $importcart = $x;

   
//exit;
  }
  
  
  
  
  
  // DELETE any existing cart with this number! If we don't do this the title and other data is not updated from the XML!
  // rddelete --carts 199123
  $output = shell_exec('rddelete --carts '.$importcart);
  echo "$output\n";
  
  
//  we dont seem to need to use the exact folder path when importing, but if we did we would use this to get it:    $currentdir=getcwd();

  // Now we run the Rivendell import to import the audio with it's XML data to the next available cart.
  // WARNING: We replace any current cart with the requested number.
  
  
  // Choose one of these to add or remove normalisation.
  // No normalisation
  $output = shell_exec('rdimport --to-cart='.$importcart.' --delete-cuts --xml '.$ret_GROUP_NAME.' '.$cartnumber.'_001.flac');
  // With normalisation. Figure is in dBFS where (in our typical case) -18 dBFS=PPM4 or -10 dBFS=PPM6.
//  $output = shell_exec('rdimport --normalization-level=-18 --to-cart='.$importcart.' --delete-cuts --xml '.$ret_GROUP_NAME.' '.$cartnumber.'_001.flac');
  
  
  echo "$output\n";
    
    
    // --add-scheduler-code=FLAG_NEW 
    // --to-cart=190001    force cart number
    // --delete-cuts  delete any existing cart contents!
    //--add-scheduler-code=FLAG_NEW  (can be used multiple times for different groups).
    // rdimport --to-cart=190001 --xml --delete-cuts --add-scheduler-code=FLAG_NEW MUSIC 100001_001.flac
    //  --delete-source
        
    
    
    
    
    
    
  // Write our data to the database CART and CUTS tables!
  
  // CART
  $sql1 = "UPDATE CART SET SONG_ID='".$ret_SONG_ID."', BPM='".$ret_BPM."', FORCED_LENGTH='".$ret_FORCED_LENGTH."', AVERAGE_LENGTH='".$ret_AVERAGE_LENGTH."', LENGTH_DEVIATION='".$ret_LENGTH_DEVIATION."', AVERAGE_SEGUE_LENGTH='".$ret_AVERAGE_SEGUE_LENGTH."', AVERAGE_HOOK_LENGTH='".$ret_AVERAGE_HOOK_LENGTH."', SCHED_CODES='".$ret_SCHED_CODES."' WHERE NUMBER=".$importcart;
  $result1 = $conn1->query($sql1);
  // The notes can be long so we do them seperatly.
  $sql1 = "UPDATE CART SET NOTES='".$allthenotes."' WHERE NUMBER=".$importcart;
  $result1 = $conn1->query($sql1);

  // CUTS - Note that DESCRIPTION is imported from XML but may contain garbage (it was mangled on our previous system(, so we replace.
  $sql2 = "UPDATE CUTS SET DESCRIPTION='Network', ORIGIN_DATETIME='".$ret_ORIGIN_DATETIME."', ORIGIN_NAME='".$ret_ORIGIN_NAME."', START_POINT='".$ret_START_POINT."', END_POINT='".$ret_END_POINT."', SEGUE_START_POINT='".$ret_SEGUE_START_POINT."', SEGUE_END_POINT='".$ret_SEGUE_END_POINT."', SEGUE_GAIN='".$ret_SEGUE_GAIN."', TALK_START_POINT='".$ret_TALK_START_POINT."', TALK_END_POINT='".$ret_TALK_END_POINT."' WHERE CART_NUMBER=".$importcart;
  $result2 = $conn2->query($sql2);
  









function mysql_escape_mimic($inp) {
    if(is_array($inp))
        return array_map(__METHOD__, $inp);

    if(!empty($inp) && is_string($inp)) {
        return str_replace(array('\\', "\0", "\n", "\r", "'", '"', "\x1a"), array('\\\\', '\\0', '\\n', '\\r', "\\'", '\\"', '\\Z'), $inp);
    }

    return $inp;
}
?>